import 'variables.dart';
import 'package:geiger_localstorage/geiger_localstorage.dart';
import 'api.dart';
import 'dart:developer';
//import 'dummyAPI/creation.dart';
//import 'dummyAPI/metricreation.dart';

//Future init() async {
//  createLocal();
//  await createThreats();
//  await createPlugin();
//  await createProfiles();
//  await createRecommendations();
//  await createEnterprise();
//  await createEnterpriseDevices();
//  await createEnterpriseUsers();
//  await createUsers();
//  await createDevices();
//  await createMetricData();
//}

Future getUUID() async {

  Storage.userUUID = await Storage().getUUID('currentUser');
//  print('Indicator'+Storage.userUUID);

  Storage.deviceUUID = await Storage().getUUID('currentDevice');

//  print('Indicator'+Storage.deviceUUID);
}

Future initPlugin() async{
  try {
    var temp = await Storage().getPlugUUID();
    var tempIDs = [];
    tempIDs = temp.split(',');
    Storage.pluginUUIDs = tempIDs;
    await initPluginUser(tempIDs);
    await initPluginDevice(tempIDs);
  }
  catch (e){
    log('indiA-initPlugin ${e.toString()}');
  }

}

Future initPluginUser(var tempIDs) async{


  for (var pluginsUUID in tempIDs) {

      try {
          var path =':' + Types.users + ':' + Storage.userUUID + ':' + pluginsUUID +
              ':data:metrics';
          var metricNode = await Storage.controller!.get(path);
          var childrenNodes = await metricNode.getChildren();
          if(childrenNodes.isNotEmpty) Storage.getValuePath.add(path);

      } catch(e) {
            log('indiB-initPluginUser ${e.toString()}');
      }


    }

}

Future initPluginDevice(var tempIDs) async{

  for (var pluginsUUID in tempIDs) {
    try {
          var path = ':' + Types.devices + ':' + Storage.deviceUUID + ':' + pluginsUUID +
              ':data:metrics';
          var metricNode = await Storage.controller
      !.get( ':' + Types.devices + ':' + Storage.deviceUUID + ':' + pluginsUUID +
      ':data:metrics');
      var childrenNodes = await metricNode.getChildren();
      if(childrenNodes.isNotEmpty) Storage.getValuePath.add(path);
      } catch(e) {
        log('indiB-initPluginDevice ${e.toString()}');
      }


  }

}

Future checkExistNodes() async {

  await generateThreats();
  //await generateCoreValues();

  await getExistScoreNodes(Types.users, Types.geigerScoreUser);
  await getExistScoreNodes(Types.devices, Types.geigerScoreDevice);

  await getExistScoreNodes(Types.users, Types.recommendations);
  await getExistScoreNodes(Types.devices, Types.recommendations);

  await getExistScoreNodes(Types.users, Types.geigerScoreAggregate);
  await getExistScoreNodes(Types.enterprise,Types.geigerScoreMSE);
}

Future generateImplementedReco(var recos, var type) async{

   if(recos.toString().contains(',')){

    var temp = recos.toString().split(',');

      for(String implementedRecommendation in temp){

        if(type == Types.users) {
          if (!CoreValues.uuidUserImplementedRecommendations.contains(
              implementedRecommendation)) {
            CoreValues.uuidUserImplementedRecommendations.add(
                implementedRecommendation);
          }
        }else if(type == Types.devices) {
          if (!CoreValues.uuidDeviceImplementedRecommendations.contains(
              implementedRecommendation)) {
            CoreValues.uuidDeviceImplementedRecommendations.add(
                implementedRecommendation);
          }
        }

      }
   }

}


Future generateCoreValues() async {
  try {
//    for (String uuidThreat in CoreValues.uuidThreats) {
//      var temp = <Node>[];
////      CoreValues.userPositive[uuidThreat] = temp;
////      temp = <Node>[];
////      CoreValues.userNegative[uuidThreat] = temp;
////      temp = <Node>[];
////      CoreValues.userRecommendation[uuidThreat] = temp;
////      temp = <Node>[];
////      CoreValues.devicePositive[uuidThreat] = temp;
////      temp = <Node>[];
////      CoreValues.deviceNegative[uuidThreat] = temp;
//      temp = <Node>[];
//      CoreValues.deviceRecommendation[uuidThreat] = temp;
//    }


  } catch (e) {
      // ignore: avoid_print
      print(e);
  }
}

Future generateThreats() async {
  try {
    var globalThreats = await Storage.controller!.get(':Global:threats');


    var nodesCsv = await globalThreats.getChildNodesCsv();
    var uuidThreats = nodesCsv.toString().split(',');
    var getChildren = await globalThreats.getChildren();
    var threatsIterator = getChildren.entries.iterator;
    var uuidIterator = uuidThreats.iterator;
    CoreValues.uuidThreats = uuidThreats;

    while (threatsIterator.moveNext()) {
      uuidIterator.moveNext();
      var nameNode = await threatsIterator.current.value.getValue('name');
      var name = nameNode!.getValue('en');
      CoreValues.uuidName[uuidIterator.current] = name;
      CoreValues.nameUUID[name] = uuidIterator.current;
    }
  }catch(e) {
      log('indiA-generateThreats ${e.toString()}');
//      registerListener(Listener.threatGlobal,':Global:threats');
//
//      try{
//        List<Event> e = await Listener.threatGlobal.getNumEvents(1);
//        print("Length of the Event ${e.length}");
//        if (e.length > 0) {
//          generateThreats();
//        }
//      } catch(e){
//
//          print(e);
//      }
  }
}

Future normalization(Iterator<MapEntry<String, Node>> nodes) async {
  var minNode = await nodes.current.value.getValue('minValue');
  var valueNode = await nodes.current.value.getValue('GEIGERvalue');
  var maxNode = await nodes.current.value.getValue('maxValue');

  var minValue = double.parse(minNode!.getValue('en').toString());
  var value = double.parse(valueNode!.getValue('en').toString());

  return (value - minValue) /
      (double.parse(maxNode!.getValue('en').toString()) - minValue);
}

Future forUpdate(var node) async {

  try {
    var minNode = await node.getValue('minValue');
    var valueNode = await node.getValue('GEIGERvalue');
    var maxNode = await node.getValue('maxValue');

    var minValue = double.parse(minNode.getValue('en').toString());
    var value = double.parse(valueNode.getValue('en').toString());


    return (value - minValue) /
        (double.parse(maxNode.getValue('en').toString()) - minValue);

  }catch(e){
    print(e);
  }


}

Future crtThreatScore(var type) async {
  var positiveMetrics = 0.0;
  var negativeMetrics = 0.0;
  var implementedRecommendations = 0.0;
  var gspt = 0.0;
  var treatsScores = '';
 // var threatScoreValues = <dynamic>[];

  for (String threatUUID in CoreValues.uuidThreats) {
    if (type == Types.devices) {
      if(CoreValues.devicePositive.isNotEmpty && CoreValues.devicePositive.containsKey(threatUUID)) positiveMetrics = await pnMetrics(CoreValues.devicePositive, threatUUID);
      if(CoreValues.deviceNegative.isNotEmpty && CoreValues.deviceNegative.containsKey(threatUUID)) negativeMetrics = await pnMetrics(CoreValues.deviceNegative, threatUUID);
      if(CoreValues.deviceImplementedRecommendation.isNotEmpty && CoreValues.deviceImplementedRecommendation.containsKey(threatUUID)) implementedRecommendations = await recoMetrics(CoreValues.deviceImplementedRecommendation, threatUUID);

    } else if (type == Types.users) {
      //positiveMetrics = await pnMetrics(CoreValues.userPositive, threatUUID);
      //negativeMetrics = await pnMetrics(CoreValues.userNegative, threatUUID);
      if(CoreValues.userPositive.isNotEmpty && CoreValues.userPositive.containsKey(threatUUID)) positiveMetrics = await pnMetrics(CoreValues.userPositive, threatUUID);
      if(CoreValues.userNegative.isNotEmpty && CoreValues.userNegative.containsKey(threatUUID)) negativeMetrics = await pnMetrics(CoreValues.userNegative, threatUUID);
      if(CoreValues.userImplementedRecommendation.isNotEmpty && CoreValues.userImplementedRecommendation.containsKey(threatUUID)) implementedRecommendations = await recoMetrics(CoreValues.userImplementedRecommendation, threatUUID);
    }

    gspt = 50 +
        (50 * negativeMetrics) -
        (25 * (positiveMetrics + implementedRecommendations));

//    var threatValues = <dynamic, dynamic>{};
//
//    threatValues['threatId'] = threatUUID;
//    threatValues['name'] = CoreValues.uuidName[threatUUID].toString().trim();
//
//    var threat = <dynamic, dynamic>{};
//
//    threat['threat'] = threatValues;
//    threat['score'] = gspt;

//    threatScoreValues.add(threat);

    treatsScores += '$threatUUID,$gspt;';

    type == Types.devices
        ? CoreValues.deviceThreatScore[threatUUID] = gspt
        : CoreValues.userThreatScore[threatUUID] = gspt;
  }



  return treatsScores;
}

Future crtTotalThreatScore(var type) async {
  var sumNumerator = 0.0;
  var sumDenominator = 0.0;
  var threatScore = {};

  type == Types.devices
      ? threatScore = CoreValues.deviceThreatScore
      : threatScore = CoreValues.userThreatScore;

  log('indiC-crtTotalThreatScore_deviceThreatScore ${CoreValues.deviceThreatScore}');
  log('indiC-crtTotalThreatScore_userThreatScore ${CoreValues.userThreatScore}');


  for (String threatUUID in CoreValues.uuidThreats) {
    //here loop threat by threat
    var rpts = await riskMetrics(threatUUID);
    log('indiC-crtTotalThreatScore_rpts $rpts');
    for (var rpt in rpts) {
      log('indiC-crtTotalThreatScore_threatScore[threatUUID] $threatScore[threatUUID]');
      //log('indiC-crtTotalThreatScore_rpt $rpt');
      sumNumerator += threatScore[threatUUID] * rpt;
      sumDenominator += rpt;
    }
  }
  log('indiC-crtTotalThreatScore_sumNumerator $sumNumerator');
  log('indiC-crtTotalThreatScore_sumDenominator $sumDenominator');
  var gspUser = sumNumerator / sumDenominator;
  if(gspUser.isNaN) {
    log('indiA - crtTotalThreatScore - Check the relatedThreatsWeights');
    gspUser = 0.0;
  }

  Node scoreNums = NodeImpl(':sn', '');
  await scoreNums.addValue(NodeValueImpl('score', gspUser.toString()));
  await scoreNums.addValue(NodeValueImpl(
      'nums',
      (CoreValues.userPositive.length + CoreValues.userNegative.length)
          .toString()));
  CoreValues.aggregate.add(scoreNums);

  return gspUser.toString();
}

Future riskMetrics(var threatUUID) async {
  var uuid = await getEnterpriseUUID();
  log('indiC-riskMetrics_uuids $uuid');
  log('indiC-riskMetrics based ${CoreValues.based}');
  log('indiC-riskMetrics enabler ${CoreValues.enabler}');
  log('indiC-riskMetrics dependent ${CoreValues.dependent}');
  var result = 0.0;
  var results = [];

  //for (var uuid in uuids) {
    //log('indiC-riskMetrics uuid ${uuid.toString().trim()}');
    switch (uuid.toString().trim()) {
      case Types.digitallyBased:
        result = double.parse(CoreValues.based[threatUUID]);
        log('indiC-riskMetrics digitallyBased result $result');
        results.add(result);
        break;

      case Types.digitalEnabler:
        result = double.parse(CoreValues.enabler[threatUUID]);
        log('indiC-riskMetrics digitalEnabler result $result');
        results.add(result);
        break;

      case Types.digitallyDependent:
        result = double.parse(CoreValues.dependent[threatUUID]);
        log('indiC-riskMetrics digitallyDependent result $result');
        results.add(result);
        break;
    }
  //}

  return results;
}

Future pnMetrics(var node, var threatUUID) async {
  var impactV = 0.0;
  var numerator = 0.0;
  var denominator = 0.0;
  var normalization = 0.0;


  var metric;
  var temp = [];

  try {
     if(node[threatUUID].toString() == temp.toString()){
       return 0.0;
     }

     metric = node[threatUUID]!.iterator;

  }catch(e){
    print('func224$e');
    return 0.0;
  }


    while (metric.moveNext()) {
      var impactNode = await metric.current.getValue('impact');
      var impact = impactNode.getValue('en');

//      try{

        var normalNode = await metric.current.getValue('normal');
        normalization = double.parse(normalNode.getValue('en'));
//
//      }catch(e){
//        print('func233$e');
//        continue;
//      }

      impactV = CoreValues.impactValues[impact.toLowerCase()]!;

      numerator += impactV * normalization; //numerator= impact*value
      denominator += impactV; //denom=impact
    }

    var result = numerator / denominator;

    return result;

//  } catch (e) {
//    return 0.0;
//  }
}

Future recoMetrics(var node, var threatUUID) async {
  var impactV = 0.0;
  var numerator = 0.0;
  var denominator = 0.0;
  var temp = [];

  try {

    if(node[threatUUID].toString() == temp.toString()){
      return 0.0;
    }

    var metric = node[threatUUID]!.iterator;

    while (metric.moveNext()) {
      var impactNode = await metric.current.getValue('impact');
      var impact = impactNode.getValue('en');

      impactV = CoreValues.impactValues[impact.toLowerCase()]!;

      //CoreValues.existReco.contains(threatUUID)
           numerator += impactV;
      //    : denominator += impactV;
    }

    return numerator / denominator;
  } catch (e) {
    print('func272$e');
    return 0.0;
  }
}

Future crtRecommendation(var type) async {
  var node = {};
  type == Types.devices
      ? node = CoreValues.deviceRecommendation
      : node = CoreValues.userRecommendation;
  var threatRecoList = [];
  var recUUID = '';
  var recoObjVList = [];
  // var recoObjList = [];

  for (String threatUUID in CoreValues.uuidThreats) {
    var recoLists = '';

    try {
      var reco = node[threatUUID]!.iterator;

      while (reco.moveNext()) {
        var impactNode = await reco.current.getValue('impact');
        var impact = impactNode.getValue('en');

        try {
          var recuuidNode = await reco.current.getValue('recuuid');
          recUUID = recuuidNode.getValue('en');
        } catch (e) {
          continue;
        }
        var impactV = CoreValues.impactValues[impact.toLowerCase()]!;

        recoLists += '$recUUID,$impactV;';

        //type =="Devices" ? coreValues.deviceThreatScore[threatUUID] = Gspt : coreValues.userThreatScore[threatUUID] = Gspt;

        var recoVal = {};
        recoVal['weight'] = impactV;
        recoVal['id'] = recUUID;
        recoVal['type'] = type.toString().toLowerCase();
        var shortNode = await reco.current.getValue('short');
        recoVal['short'] = shortNode.getValue('en');
        var longNode = await reco.current.getValue('long');
        recoVal['long'] = longNode.getValue('en');

        recoObjVList.add(recoVal);
      }
      if(recoLists.isNotEmpty) threatRecoList.add(NodeValueImpl(threatUUID, recoLists));

      var threatVal = {};
      threatVal['threatId'] = threatUUID;
      threatVal['name'] = CoreValues.uuidName[threatUUID].toString().trim();

      var recoObj = {};
      recoObj['threat'] = threatVal;
      recoObj['recommendations'] = recoObjVList;

      var recoObjKey = {};
      recoObjKey['recommendations'] = recoObj;


    } catch (e) {
      continue;
    }
  }

  return threatRecoList;
}

Future crtAggregateScore() async {
  var sumNumerator = 0.0;
  var sumDenominator = 0.0;

  for (Node scoreNums in CoreValues.aggregate) {
    var scoreNode = await scoreNums.getValue('score');
    var gsp = double.parse(scoreNode!.getValue('en').toString());
    var numsNode = await scoreNums.getValue('score');
    var ns = double.parse(numsNode!.getValue('en').toString());
    sumNumerator += (gsp * ns);
    sumDenominator += ns;
  }
  CoreValues.gagg = sumNumerator / sumDenominator;
  CoreValues.nagg = sumDenominator;
}



Future registerListener(var l, var path, var type) async{
//  final localMaster =
//  (await getGeigerApi("", 'abc', Declaration.doShareData))
//  !;
//  var st = localMaster.getStorage();
  SearchCriteria s = SearchCriteria(searchPath: path);
  s.set(Field.type, type);
  Storage.controller!.registerChangeListener(l, s);
 // st!.registerChangeListener(l, s);
  //log('Listener======>$s');
  //print('Listener======>$s');

}

